#!/usr/bin/python
# mythremote.py
# Beginings of my myth remote script
#from distutils.core import setup

#setup(
#       name='MythTV',
#       version='0.21',
#       description='MythTV Python bindings.',
#       packages=['MythTV']
#       )

import gtk
import hildon
import threading
import time

gtk.gdk.threads_init()

def main_quit(obj, data):
   global su
   global remote
   su.stop()
   gtk.main_quit()
   remote.frontend_disconnect()
    
class MythRemote():
   remoteAddress = "192.168.0.100"
   remotePort = 6546

   def __init__(self):
     gtk.set_application_name("MythTV Remote")
     self.program = hildon.Program.get_instance()
     self.frontend_connect()
     self.update_status()

   def frontend_connect(self):
     from MythClasses import Frontend
     self.socket = Frontend(self.remoteAddress, self.remotePort)
     time.sleep(0.2)
     self.socket.connect()
  
   def frontend_disconnect(self):
     self.socket.disconnect()

   def create_menu(self):
     menu = hildon.AppMenu()
     button = hildon.GtkButton(gtk.HILDON_SIZE_AUTO)
     button.set_label("Configure")
     menu.append(button)
     menu.show_all()
     return menu

   def key_press_event(self, widget, event) :
     key = gtk.gdk.keyval_name (event.keyval) 
     self.socket.sendKey(key.lower())

   def update_status(self):
     global status
     global times
     global adj1
     self.status = self.socket.sendQuery('location')
     self.status = self.status.split(' ')
     if self.status[0] == 'Playback':
       self.position = self.status[2]
       self.position_s = hms_secs(self.status[2])
       self.length = self.status[4]
       self.length_s = hms_secs(self.status[4])
       adj1.value = self.position_s
       adj1.upper = self.length_s
       times.set_text(self.position + ' of ' + self.length)
     status.set_text(self.status[0])

   def create_window(self):
     self.window = hildon.StackableWindow()
     self.program.add_window(self.window)
#     hildon.keyboard_grab(self.window, owner_events=False, time=0L)
     self.window.connect('delete_event', main_quit)
     self.window.connect("key-press-event", self.key_press_event)
#     self.window.connect('destroy', self.frontend_disconnect)

   def button_clicked(self, button, status):
     if button.get_title() == 'UP':
       self.socket.sendKey('up')
     elif button.get_title() == 'LEFT':
       self.socket.sendKey('left')
     elif button.get_title() == 'RIGHT':
       self.socket.sendKey('right')
     elif button.get_title() == 'DOWN':
       self.socket.sendKey('down')
     elif button.get_title() == 'OK':
       self.socket.sendKey('space')
     elif button.get_title() == 'BACK':
       self.socket.sendKey('escape')
     elif button.get_title() == 'MENU':
       self.socket.sendKey('m')
     elif button.get_title() == 'i':
       self.socket.sendKey('i')
     elif button.get_title() == 'Play':
       self.socket.sendKey('p')
     elif button.get_title() == '|< Skip':
       self.socket.sendKey('home')
     elif button.get_title() == 'Skip >|':
       self.socket.sendKey('end')
     elif button.get_title() == '<< RW':
       self.socket.sendKey('<')
     elif button.get_title() == 'FF >>':
       self.socket.sendKey('>')
     self.update_status()



class StatusSetter(threading.Thread):

   stopthread = threading.Event()

   def run(self):
     global remote
     while not self.stopthread.isSet():
       gtk.gdk.threads_enter()
       remote.update_status()
       gtk.gdk.threads_leave()
       time.sleep(1)

   def stop(self):
     self.stopthread.set()



def scale_set_default_values(scale):
   scale.set_update_policy(gtk.UPDATE_CONTINUOUS)
   scale.set_digits(1)
   scale.set_value_pos(gtk.POS_TOP)
   scale.set_draw_value(False)


def hms_secs(data):
   data = data.split(':')
   return int(data[0])*36000 + int(data[1])*60 + int(data[2])



def main():
   global status
   global times
   global remote
   global su
   global adj1

   status = gtk.Label()
   times = gtk.Label()
   adj1 = gtk.Adjustment(0.0, 0.0, 10000, 1)

   remote = MythRemote()
   remote.create_window()

   table = gtk.Table(rows=6, columns=5, homogeneous=True)

   
   table.attach(status, 0, 5, 0, 1)
   
   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('UP')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 2, 3, 1, 2)

   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('LEFT')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 1, 2, 2, 3)

   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('OK')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 2, 3, 2, 3)
 
   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('RIGHT')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 3, 4, 2, 3)
  
   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('DOWN')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 2, 3, 3, 4)
   
   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('BACK')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 0, 1, 1, 2)
   
   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('MENU')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 4, 5, 1, 2)

   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('i')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 4, 5, 3, 4)

   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('Play')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 2, 3, 4, 5)

   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('|< Skip')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 1, 2, 4, 5)

   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('Skip >|')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 3, 4, 4, 5)

   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('FF >>')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 4, 5, 4, 5)

   button = hildon.Button(gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
   button.set_title('<< RW')
   button.connect("clicked", remote.button_clicked, status)
   table.attach(button, 0, 1, 4, 5)

   # value, lower, upper, step_increment, page_increment, page_size
   # Note that the page_size value only makes a difference for
   # scrollbar widgets, and the highest value you'll get is actually
   # (upper - page_size).
#   adj1 = gtk.Adjustment(0.0, 0.0, 10000, 1)

   position = gtk.HScale(adj1)
   scale_set_default_values(position)

   table.attach(position, 0, 3, 5, 6)   

#   start = gtk.Label('0')

#   table.attach(start, 0, 1, 6, 7)
   table.attach(times, 3, 5, 5, 6)

   table.set_row_spacings(6)
   table.set_col_spacings(6)
   
   remote.window.add(table)

   menu = remote.create_menu()
   remote.window.set_app_menu(menu)

   remote.window.show_all()
   
   su = StatusSetter()
   su.start()
   
   gtk.main()
   return 0
   
if __name__ == "__main__":
   main()
   

#remote.frontend_disconnect()

